#############################################################################
# ___  __.                                             __                   #
#|   |/ _|______   ____  ____   ____      ____   _____/  |_  _______ __ __  #
#|     < \_  __ \_/ __ \/  _ \ /    \    /    \_/ __ \   __\ \_  __ \  |  \ #
#|   |  \ |  | \/\  ___(  <_> )   |  \  |   |  \  ___/|  |    |  | \/  |  / #
#|___|__ \|__|    \___  >____/|___|  / /\___|  /\___  >__|   /\__|  |____/  #
#       \/            \/           \/  \/    \/     \/       \/             #
#                              D i g i t a l   S i d e   o f   L i f e      #
#############################################################################
#
# reals.tcl v1100100
#
# :
#            ,
#  ,   .
#	  .
#
# : Kreon @ Zelan
#
# : http://kreon.net.ru
# 
##############################################################################

namespace eval realka {
	set realka(credits) "v1100100 by Kreon"
	#     ,     -   [path/to/file]
	set realka(datafile) "scripts/reals.dat"
	#     /  [flags]
	set realka(flagtocreate) "o"
	#       ["#chan";"#chan2";"#chan3"]
	set realka(chanslist) {
		"#eggdrop"
		"#asd"
	}
	#     : 1 - *!ident@*.host, 2 - *!*@host, 3 - nick!ident@*, 
	# 4 - *!ident@host, 5 - $nick!*@* [1-5]
	set realka(mask) 4
	#     ? [1/0]
	set realka(cleanreport) 1
	#     ? [1/0]
	set realka(enablechangemind) 1
	#     ? [1/0]
	set realka(showstatinchan) 1
	#   ,   ? [1/0]
	set realka(showblank) 0
	#      ? [1/0]
	set realka(enableonjoin) 1
	#        ? [1/0]
	set realka(forceonjoin) 1
	#     /      ? [1/1]
	set realka(useram) 1
	set realka(testvar) 0
}
bind join - * ::realka::on_join
#-------------------------------------------
bind pub - "!" ::realka::pubrealka
bind msg - "!" ::realka::msgrealka
#-------------------------------------------

#---------------------------------------------------------------------------------#
# DONT CHANGE ANYTHING BELOW UNTIL YOU KNOW WHAT YOU ARE DOING                    #
#---------------------------------------------------------------------------------#

proc ::realka::msgrealka {nick uhost hand text} {
	::realka::pubrealka $nick $uhost $hand $nick $text
}
proc ::realka::pubrealka {nick uhost hand chan text} {global sp_version
	if {$nick eq $chan} {
		if {[string index $text 0] != "#"} {putmsg $nick "      #.";return}
		set rchan [tolower [lindex $text 0]]
		set text [lrange $text 1 end]
	} else {set rchan $chan}
	if {![info exists sp_version]} {set text [encoding convertfrom [encoding system] $text]}
	regsub -all {[\002\026\037]|\003\d{0,2}(,\d{0,2})?} $text "" textswitch
	switch -- [lindex $textswitch 0] {
		"" {newrealka $nick $uhost $hand $chan [tolower $rchan] [lrange $text 1 end]}
		"" {changerealka $nick $uhost $hand $chan [tolower $rchan] [lrange $text 1 end]}
		"" {newrealka $nick $uhost $hand $chan [tolower $rchan] ""}
		"" {statrealka $nick $uhost $hand $chan [tolower $rchan] [lrange $textswitch 1 end]}
		"" {cleanrealka $nick $uhost $hand $chan [tolower $rchan] [lrange $textswitch 1 end]}
		"" {ansrealka $nick $uhost $hand $chan [tolower $rchan] [lrange $textswitch 1 end]}
		"" {statrealka $nick $uhost $hand $chan [tolower $rchan] [lrange $textswitch 1 end]}
		default {helprealka $nick $uhost $hand $chan [tolower $rchan] [lrange $textswitch 1 end]}
	}
}
proc ::realka::readdata {} {
	variable realka
	if {![file exists $realka(datafile)]} {return}
	foreach p [array names realka "#*"] {
		catch {unset realka($p)}
	}
	set fd [open $realka(datafile) r]
	set rchan "#unknown"
	while {![eof $fd]} {
		gets $fd line
		if {[string index $line 0] == "#"} {
			set line [split $line "~"]
			set rchan [lindex $line 0]
			set realka($rchan,topic) [join [lrange $line 1 end]]
			continue
		}
		lappend realka($rchan,users) $line
	}
	close $fd
}
proc ::realka::writedata {} {
	variable realka
	regexp -- {^(\S+/)?.*$} $realka(datafile) tmp directory
	if {$directory != ""} {
  	 if {![file isdirectory $directory]} {
			file mkdir $directory
		}
	}
	set fd [open $realka(datafile) w]
	foreach q $realka(chanslist) {
		if {[info exists realka($q,topic)]} {
			puts $fd "$q~$realka($q,topic)"
		} else {continue}
		foreach p $realka($q,users) {
			if {$p == ""} {continue}
			puts $fd $p
		}
	}
	close $fd
}
proc ::realka::newrealka {nick uhost hand chan rchan text} {
	variable realka
	if {![matchattr [nick2hand $nick] $realka(flagtocreate) $rchan]} {return}
	if {[lsearch [tolower $realka(chanslist)] $rchan] == -1} {putpvt $nick $chan "     $rchan."; return}
	if {$text != ""} {
		foreach p [array names realka $rchan*] {
			catch {unset realka($p)}
		}
		set realka($rchan,topic) $text
		set realka($rchan,users) ""
		putmsg $rchan "  : $text"
	} elseif {[info exists realka($rchan,topic)]} {
		foreach p [array names realka $rchan*] {
			catch {unset realka($p)}
		}
		putmsg $rchan " ."
	}
	writedata
}

proc ::realka::statrealka {nick uhost hand chan rchan text} {
	variable realka
	if {[lsearch [tolower $realka(chanslist)] $rchan] == -1} {return}
	if {![info exists realka($rchan,topic)]} {putpvt $nick $chan "   $rchan     .";return}
	set list1 ""
	set list2 ""
	set list3 ""
	foreach p $realka($rchan,users) {
		if {$p == ""} {continue}
		switch -- [lindex $p 2] {
			1 {lappend list1 [lindex $p 0]}
			2 {lappend list2 [lindex $p 0]}
			3 {lappend list3 [lindex $p 0]}
			default {}
		}
	}
	if {$chan eq $nick || $realka(showstatinchan)} {
		putmsg $chan " : $realka($rchan,topic)"
		if {[llength $list1]} {putmsg $chan "[expr {[llength $list1] > 1 ? "" : ""}]  : [join $list1 ", "]"}
		if {[llength $list2]} {putmsg $chan "[expr {[llength $list2] > 1 ? "" : ""}] : [join $list2 ", "]"}
		if {[llength $list3]} {putmsg $chan "  [expr {[llength $list3] > 1 ? "" : ""}]  : [join $list3 ", "]"}
		if {$realka(showblank) && ![expr [llength $list1] + [llength $list2] + [llength $list3]]} {putmsg $chan "   ."}
	} else {
		putnot $nick " : $realka($rchan,topic)"
		if {[llength $list1]} {putnot $nick "[expr {[llength $list1] > 1 ? "" : ""}]  : [join $list1 ", "]"}
		if {[llength $list2]} {putnot $nick "[expr {[llength $list2] > 1 ? "" : ""}] : [join $list2 ", "]"}
		if {[llength $list3]} {putnot $nick "  [expr {[llength $list3] > 1 ? "" : ""}]  : [join $list3 ", "]"}
		if {$realka(showblank) && ![expr [llength $list1] + [llength $list2] + [llength $list3]]} {putmsg $chan "   ."}
	}
}

proc ::realka::changerealka {nick uhost hand chan rchan text} {
	variable realka
	if {![matchattr [nick2hand $nick] $realka(flagtocreate) $rchan]} {return}
	if {[lsearch [tolower $realka(chanslist)] $rchan] == -1} {putpvt $nick $chan "     $rchan."; return}
	if {![info exists realka($rchan,topic)]} {newrealka $nick $uhost $hand $chan [tolower $rchan] [lrange $text 1 end];return}
	set realka($rchan,topic) $text
	writedata
	putmsg $rchan "     \"$realka($rchan,topic)\",     ."
}
proc ::realka::cleanrealka {nick uhost hand chan rchan text} {
	variable realka
	if {![matchattr [nick2hand $nick] $realka(flagtocreate) $rchan]} {return}
	if {[lsearch [tolower $realka(chanslist)] $rchan] == -1} {putpvt $nick $chan "     $rchan."; return}
	if {![info exists realka($rchan,topic)]} {putpvt $nick $chan "   $rchan     ,   .";return}
	set realka($rchan,users) ""
	writedata
	if {$realka(cleanreport)} {putmsg $rchan "   ."}
	if {$nick eq $chan} {putpvt $nick $chan " ."}
}
proc ::realka::helprealka {nick uhost hand chan rchan text} {
	variable realka
	if {$nick eq $chan && [lsearch [tolower $realka(chanslist)] $rchan] == -1 && [matchattr [nick2hand $nick] $realka(flagtocreate) $rchan]} {return}
	putpvt $nick $chan "        ."
	putpvt $nick $chan "    ,      -        -  !  \[||\].       ! .        ,    #."
	if {![matchattr [nick2hand $nick] $realka(flagtocreate) $rchan]} {return}
	putpvt $nick $chan "  : !  \"\",     : !  \" \",  : ! ,  : ! ."
}
proc ::realka::ansrealka {nick uhost hand chan rchan text} {
	variable realka
	if {[lsearch [tolower $realka(chanslist)] $rchan] == -1} {return}
	if {![info exists realka($rchan,topic)]} {putpvt $nick $chan "   $rchan     .";return}
	switch -- $text {
		"" {set ans 1}
		"" {set ans 2}
		"" {set ans 3}
		"" {set ans 3}
		" " {set ans 3}
		"" {set ans 0}
		default {putpvt $nick $chan "  : \"\", \"\", \"\"       .";return}
	}
	switch $realka(mask) {
		1 {set host [maskhost $uhost]}
		2 {set host "*!*@[lindex [split $uhost "@"] 1]"}
		3 {set host "$nick![lindex [split $uhost "@" 0]@*"}
		4 {set host "*!$uhost"}
		5 {set host "$nick!*@*"}
		default {set host "*!$uhost"}
	}
	set i 0
	foreach p $realka($rchan,users) {
		if {[lindex $p 1] eq $host} {
			if {[lindex $p 2] != $ans} {
				if {[lindex $p 0] != $nick} {
					if {!$realka(enablechangemind)} {putpvt $nick $chan "        [lindex $p 0] ([lindex $p 1]),    \"[getanswer [lindex $p 2]]\"       ."; return}
					putpvt $nick $chan "        [lindex $p 0] ([lindex $p 1]),     ."
				} else {
					if {!$realka(enablechangemind)} {putpvt $nick $chan "      ([lindex $p 1]),    [getanswer [lindex $p 2]]       ."; return}
					putpvt $nick $chan "  ."
				}
				set realka($rchan,users) [lreplace $realka($rchan,users) $i $i "$nick $host $ans"]
				writedata
				return
			} else {
				if {[lindex $p 0] != $nick} {
					putpvt $nick $chan "         [lindex $p 0] ([lindex $p 1]),      ."
					set realka($rchan,users) [lreplace $realka($rchan,users) $i $i "$nick $host $ans"]
					writedata
				} else {
					putpvt $nick $chan "       ([lindex $p 1])."
				}
				return
			}
		}
		if {[lindex $p 0] eq $nick} {
			if {[lindex $p 2] != $ans} {
				if {[lindex $p 1] != $host} {
					if {!$realka(enablechangemind)} {putpvt $nick $chan "         [lindex $p 1],    \"[getanswer [lindex $p 2]]\"       ."; return}
					putpvt $nick $chan "         [lindex $p 0]   [lindex $p 1],     ."
				}
				set realka($rchan,users) [lreplace $realka($rchan,users) $i $i "$nick $host $ans"]								
			} else {
					putpvt $nick $chan "          [lindex $p 0]   [lindex $p 1],      ."				
					set realka($rchan,users) [lreplace $realka($rchan,users) $i $i "$nick $host $ans"]
			}
			writedata
			return
		}
		incr i
	}
	lappend realka($rchan,users) "$nick $host $ans"
	putpvt $nick $chan "  ."
	writedata
}

proc ::realka::on_join {nick uhost hand chan} {
	variable realka
	if {[lsearch [tolower $realka(chanslist)] [tolower $chan]] == -1 || !$realka(enableonjoin) || ![info exists realka($chan,topic)]} {return}
	
	switch $realka(mask) {
		1 {set host [maskhost $uhost]}
		2 {set host "*!*@[lindex [split $uhost "@"] 1]"}
		3 {set host "$nick![lindex [split $uhost "@" 0]@*"}
		4 {set host "*!$uhost"}
		5 {set host "$nick!*@*"}
		default {set host "*!$uhost"}
	}
	foreach p $realka($chan,users) {
		if {[lindex $p 1] eq $host} {
			if {!$realka(forceonjoin)} {return}
			putpvt $nick $chan "   : \"$realka($chan,topic)\".         - \"[getanswer [lindex $p 2]]\".[expr {$realka(enablechangemind) ? "      !  \[||\]" : ""}]"
			return
		}
		if {[lindex $p 0] eq $nick} {
			if {!$realka(forceonjoin)} {return}
			putpvt $nick $chan "   : \"$realka($chan,topic)\".         - \"[getanswer [lindex $p 2]]\".[expr {$realka(enablechangemind) ? "      !  \[||\]" : ""}]"			
			return
		}
	}
	putpvt $nick $chan "   : \"$realka($chan,topic)\".      ! ,   ,  !  \[||\]."
}

proc ::realka::getanswer {t} {
	switch -- $t {
		0 {return " "}
		1 {return ""}
		2 {return " "}
		3 {return " "}
		default {return "error"}
	}
}
proc ::realka::putout {cmd dest msg} { global botnick
	set maxlen [expr 510 - [string length "$botnick![getchanhost $botnick] $cmd $dest :"]]
	while {$msg != ""} {
		set text [expr {[string length $msg] > $maxlen ? [string range $msg 0 [string last \x20 [string range $msg 0 $maxlen]]] : $msg}]
		putserv "$cmd $dest :$text"
		set msg [string trim [string range $msg [string length $text] end]]
	}
}

proc ::realka::tolower {t} {
	global sp_version
	if {[info exists sp_version]} {return [string tolower $t]} else {return [encoding convertto cp1251 [string tolower [encoding convertfrom cp1251 $t]]]}
}

proc ::realka::putmsg {nick msg} { putout PRIVMSG $nick $msg }
proc ::realka::putnot {nick msg} { putout NOTICE $nick $msg }
proc ::realka::putact {dest msg} { putserv "PRIVMSG $dest :\001ACTION $msg\001" }
proc ::realka::putpvt {nick chan msg} {
	if {[validchan $chan]} {
		putnot $nick $msg
	} else {
		putmsg $nick $msg
	}
}
namespace eval realka {
	readdata
	putlog "reals.tcl $realka(credits) loaded."
}
